#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>

struct phonebookentry {
        char name[64];
        long int phonenumber;
        char flags[16];
};

struct arguments {
        struct phonebookentry *apbe;
        long int phonenumber;
};

pthread_mutex_t mutex;
int data_acquired=0;

void *fetch(struct arguments *);

#define NUM_PHONEBOOK_ENTRIES 4
struct phonebookentry phonebook[NUM_PHONEBOOK_ENTRIES]={{"alex",9999999,"home"},{"david",2222222,"mobile"},{"matthew",3333333,"work"},{"sarah",123456789,"mobile"}};

int main (void)
{
	struct arguments *arg;
	struct phonebookentry *results;
        pthread_t thread_id[4];
	long int i,lookup_numbers[4]={9999999,2222222,3333333,4444444};

	pthread_mutex_init(&mutex, NULL);

	arg=calloc(1,sizeof(struct arguments));	
	results=calloc(4,sizeof(struct phonebookentry));
	
	for(i=0;i<4;i++)
	  {
	    /*pthread_mutex_lock(&mutex);*/
	    arg->phonenumber=lookup_numbers[i];
	    arg->apbe=&(results[i]);
	    data_acquired=0;
	    /*pthread_mutex_unlock(&mutex);*/
	    
	    if(pthread_create(&thread_id[i], NULL, fetch, arg)!= 0)
	      {
		printf("Error on Create thread\n");
		return 1;
	      }
	    
	      while(data_acquired==0)/*wait until the thread acquires data*/
	      {
		/*do nothing*/
	      }
	  }

	/* do something else for a bit */
	printf("Main doing something else for now...watch the CPU Usage!!!\n");
	
	/* wait for all threads to finish */
	printf("Waiting for all threads to finish\n");
	for(i=0;i<4;i++)
	  {
	    if(pthread_join(thread_id[i], NULL)!= 0)
	      printf("Error on Join thread %d, or number not found\n",i);
	    else
	      printf("Success of thread %d, resilt: %s\n",i, results[i].name);
	  }
        
	printf("All threads finished\n");
	
	return 0;
}

void *fetch(struct arguments *arg)
{
	long int i,number;
	struct phonebookentry *npbe;
	
	/*pthread_mutex_lock(&mutex);*/
	number=arg->phonenumber;
	npbe=arg->apbe;
	data_acquired=1;
	/*pthread_mutex_unlock(&mutex);*/

        /* fetch value from a database */
       
	printf("Thread: Fetch started, looking for %d\n",number);
	while(i<1000*number) /*simulate long database lookup*/
	  i=i+1;
	
	for(i=0;i<NUM_PHONEBOOK_ENTRIES;i++) /*doing the actual lookup*/
	{
	  if(phonebook[i].phonenumber==number)
	    {
	      *npbe=phonebook[i];
	      break;
	    }
	}

	if (i<NUM_PHONEBOOK_ENTRIES)
	  {
	    printf("Thread: Found name %s, number %d\n",npbe->name,npbe->phonenumber);
	    pthread_exit(0);
	  }
	else
	  {
	    printf("Thread: Not found\n");
	    pthread_exit(1);
	  }
}


